﻿namespace Memento1
{
    //Originator
    public class Calculadora
    {
        private int resultado;
        public Calculadora(int i = 0)
        {
            resultado = 0;
        }
        public void SetResult(int i = 0)
        {
            this.resultado = 0;
        }
        public void Soma(int x)
        {
            resultado += x;
        }
        public void Subtrai(int x)
        {
            resultado -= x;
        }
        public int GetResult()
        {
            return resultado;
        }
        public Memento CreateMemento()
        {
            Memento memento = new Memento();
            memento.SetState(resultado);
            return memento;
        }
        public void SaveState(Memento memento)
        {
            resultado = memento.GetState();
        }
    }
}
