﻿using System;

namespace Memento1
{
    class Program
    {
        static void Main(string[] args)
        {
            Calculadora calculator = new Calculadora();
            calculator.Soma(5);
            calculator.Soma(10);
            calculator.Subtrai(10);

            //salva o estado original 
            Memento estadoOriginal = calculator.CreateMemento();

            //altera o estado
            calculator.Soma(100);
            Console.WriteLine("Valor do resultado : " +calculator.GetResult());

            //restaura o estado original
            calculator.SaveState(estadoOriginal);
            Console.WriteLine("Valor do resultado original : " +calculator.GetResult());
            
            Console.Read();
        }
    }
}
